<!-- tab ประวัติการศึกษา -->
<template>
  <q-form ref="myForm">
    <Table
      :rows="rows"
      :columns="columns"
      :filter="filter"
      :visible-columns="visibleColumns"
      v-model:inputfilter="filter"
      v-model:inputvisible="visibleColumns"
      v-model:editvisible="edit"
      :add="clickAdd"
      :edit="clickEdit"
      :addData="false"
      :editData="status == 'checkRegister' || status == 'payment'"
      name="ประวัติการศีกษา"
      icon="mdi-school"
    >
      <template #columns="props">
        <q-tr :props="props">
          <q-td
            v-for="col in props.cols"
            :key="col.name"
            :props="props"
            @click="selectData(props)"
            class="cursor-pointer"
          >
            <div v-if="col.name == 'duration'" class="">
              {{ dateThaiRange(col.value) }}
            </div>
            <div v-else class="">
              {{ col.value }}
            </div>
          </q-td>
          <q-td
            auto-width
            v-if="status == 'checkRegister' || status == 'payment'"
          >
            <q-btn
              color="red"
              flat
              dense
              round
              size="14px"
              icon="mdi-trash-can-outline"
              @click="checkDelete(props.row)"
            />
          </q-td>
        </q-tr>
      </template>
    </Table>
  </q-form>
  <!-- popup Edit window-->
  <q-dialog v-model="modal" persistent>
    <q-card style="width: 600px">
      <q-form ref="myForm">
        <DialogHeader tittle="ประวัติการศึกษา" :close="checkClose" />
        <q-separator />
        <q-card-section class="q-p-sm">
          <div
            class="row col-12 items-center q-col-gutter-x-xs q-col-gutter-y-xs"
          >
            <div class="col-xs-6 col-sm-6 col-md-6">
              <q-select
                :class="getClass(edit)"
                :outlined="edit"
                dense
                lazy-rules
                :readonly="!edit"
                :borderless="!edit"
                v-model="educationLevelId"
                :rules="[(val) => !!val || `${'กรุณาเลือกวุฒิที่ได้รับ'}`]"
                :label="`${'วุฒิที่ได้รับ'}`"
                @update:modelValue="clickEditRow"
                emit-value
                map-options
                option-label="name"
                :options="educationLevelOptions"
                option-value="id"
                hide-bottom-space
              />
            </div>
            <div class="col-xs-6 col-sm-6 col-md-6">
              <q-input
                :class="getClass(edit)"
                :outlined="edit"
                dense
                lazy-rules
                :readonly="!edit"
                :borderless="!edit"
                v-model="major"
                :rules="[(val) => !!val || `${'กรุณากรอกสาขาวิชา/วิชาเอก'}`]"
                :label="`${'สาขาวิชา/วิชาเอก'}`"
                @update:modelValue="clickEditRow"
                hide-bottom-space
              />
            </div>
            <div class="col-xs-6 col-sm-6 col-md-6">
              <q-input
                type="number"
                :class="getClass(edit)"
                :outlined="edit"
                dense
                lazy-rules
                :readonly="!edit"
                :borderless="!edit"
                v-model="scores"
                :rules="[
                  (val) => !!val || `${'กรุณากรอกคะแนนเฉลี่ยตลอดหลักสูตร'}`,
                ]"
                :label="`${'คะแนนเฉลี่ยตลอดหลักสูตร'}`"
                @update:modelValue="clickEditRow"
                hide-bottom-space
              />
            </div>
            <div class="col-xs-6 col-sm-6 col-md-6">
              <q-input
                :class="getClass(edit)"
                :outlined="edit"
                dense
                lazy-rules
                :readonly="!edit"
                :borderless="!edit"
                v-model="name"
                :rules="[(val) => !!val || `${'กรุณากรอกชื่อสถานศึกษา'}`]"
                :label="`${'ชื่อสถานศึกษา'}`"
                @update:modelValue="clickEditRow"
                hide-bottom-space
              />
            </div>
            <div class="col-xs-6 col-sm-6 col-md-6">
              <datepicker
                :readonly="!edit"
                v-model="duration"
                :locale="'th'"
                autoApply
                range
                :enableTimePicker="false"
                week-start="0"
              >
                <template #year="{ year }">
                  {{ year + 543 }}
                </template>
                <template #year-overlay-value="{ value }">
                  {{ parseInt(value + 543) }}
                </template>
                <template #trigger>
                  <q-input
                    :class="getClass(edit)"
                    class="datepicker"
                    :outlined="edit"
                    dense
                    lazy-rules
                    :borderless="!edit"
                    :model-value="dateThaiRange(duration)"
                    hide-bottom-space
                  >
                    <template v-slot:prepend>
                      <q-icon
                        name="mdi-calendar-outline"
                        class="cursor-pointer"
                        style="color: var(--q-primary)"
                      >
                      </q-icon>
                    </template>
                  </q-input>
                </template>
              </datepicker>
            </div>
          </div>
        </q-card-section>
        <q-separator />
        <DialogFooter
          :edit="clickEdit"
          :save="clickSave"
          :validate="validateData"
          :clickNext="clickNext"
          :clickPrevious="clickPrevious"
          :editData="status == 'checkRegister' || status == 'payment'"
          v-model:editvisible="edit"
          v-model:next="next"
          v-model:previous="previous"
          v-model:modalEdit="modalEdit"
        />
      </q-form>
    </q-card>
  </q-dialog>
</template>
<script setup lang="ts">
import type { QTableProps } from "quasar";
import { onMounted, ref, watch } from "vue";
import { useQuasar } from "quasar";
import { useCounterMixin } from "@/stores/mixin";
import http from "@/plugins/http";
import config from "@/app.config";

import { useExamDataStore } from "@/modules/03_recruiting/store";
import type {
  RequestItemsObject,
  DataProps,
} from "@/modules/03_recruiting/interface/request/Education";
import type { DataOption } from "@/modules/03_recruiting/interface/index/Main";
import type { ResponseObject } from "@/modules/03_recruiting/interface/response/Education";
import Table from "@/modules/03_recruiting/components/TableCan.vue";
import DialogHeader from "@/modules/03_recruiting/components/DialogHeader.vue";
import DialogFooter from "@/modules/03_recruiting/components/DialogFooter.vue";
import { useRoute } from "vue-router";

const props = defineProps({
  status: {
    type: String,
    required: true,
  },
});

const $q = useQuasar();
const mixin = useCounterMixin(); //เรียกฟังก์ชันกลาง
const { dateThaiRange, modalDelete, modalConfirm, dateToISO, success } = mixin;
const store = useExamDataStore();
const { examData, changeExamColumns } = store;
const id = ref<string>("");
const educationLevel = ref<string>();
const educationLevelId = ref<string>();
const educationLevelOptions = ref<DataOption[]>([]);
const major = ref<string>();
const scores = ref<number | null>();
const name = ref<string>();
const duration = ref<[Date, Date]>([new Date(), new Date()]);
const myForm = ref<any>(); //form data input
const edit = ref<boolean>(true); //เช็คการกดปุ่มแก้ไขใน dialog
const modal = ref<boolean>(false); //modal add detail
const modalEdit = ref<boolean>(false); //modal ที่แสดงใช้สำหรับแก้ไขหรือไม่
const rawItem = ref<RequestItemsObject>(); //ข้อมูลเดิมที่เลือกใน row นั้น
const rowIndex = ref<number>(0); //indexข้อมูลเดิมที่เลือกใน row นั้น
const previous = ref<boolean>(); //แสดงปุ่มดูข้อมูลก่อนหน้า
const next = ref<boolean>(); //แสดงปุ่มดูข้อมูลต่อไป
const editRow = ref<boolean>(false); //เช็คมีการแก้ไขข้อมูล
const checkValidate = ref<boolean>(false); //validate data ผ่านหรือไม่
const rows = ref<RequestItemsObject[]>([]);
const route = useRoute();

const { messageError, showLoader, hideLoader } = mixin;
const candidateId = ref<string>(route.params.candidateId.toString());
const filter = ref<string>(""); //search data table

const visibleColumns = ref<String[]>([]);

examData.education.columns.length == 0
  ? (visibleColumns.value = [
      "educationLevel",
      "major",
      "scores",
      "name",
      "duration",
    ])
  : (visibleColumns.value = examData.education.columns);

const columns = ref<QTableProps["columns"]>([
  {
    name: "educationLevel",
    align: "left",
    label: "วุฒิที่ได้รับ",
    sortable: true,
    field: "educationLevel",
    headerStyle: "font-size: 14px",
    style: "font-size: 14px",
    sort: (a: string, b: string) =>
      a.localeCompare(b, undefined, { numeric: true, sensitivity: "base" }),
  },
  {
    name: "major",
    align: "left",
    label: "สาขาวิชา/วิชาเอก",
    sortable: true,
    field: "major",
    headerStyle: "font-size: 14px",
    style: "font-size: 14px",
    sort: (a: string, b: string) =>
      a.localeCompare(b, undefined, { numeric: true, sensitivity: "base" }),
  },
  {
    name: "scores",
    align: "left",
    label: "คะแนนเฉลี่ยตลอดหลักสูตร",
    sortable: true,
    field: "scores",
    headerStyle: "font-size: 14px",
    style: "font-size: 14px",
    sort: (a: string, b: string) =>
      a.localeCompare(b, undefined, { numeric: true, sensitivity: "base" }),
  },
  {
    name: "name",
    align: "left",
    label: "ชื่อสถานศึกษา",
    sortable: true,
    field: "name",
    headerStyle: "font-size: 14px",
    style: "font-size: 14px",
    sort: (a: string, b: string) =>
      a.localeCompare(b, undefined, { numeric: true, sensitivity: "base" }),
  },
  {
    name: "duration",
    align: "left",
    label: "ระยะเวลา",
    sortable: true,
    field: "duration",
    headerStyle: "font-size: 14px",
    style: "font-size: 14px",
    sort: (a: string, b: string) =>
      a.localeCompare(b, undefined, { numeric: true, sensitivity: "base" }),
  },
]);

watch(visibleColumns, async (count: String[], prevCount: String[]) => {
  await changeExamColumns("education", count);
});

onMounted(async () => {
  await fetchData();
  await fetcheducationLevel();
});

const fetchData = async () => {
  showLoader();
  await http
    .get(config.API.candidateEducation(candidateId.value))
    .then((res) => {
      const data = res.data.result;
      rows.value = [];
      data.map((r: ResponseObject) => {
        rows.value.push({
          ...r,
          educationLevelId: r.educationLevelId,
          educationLevel: r.educationLevelName,
          duration: [r.durationStart, r.durationEnd],
        });
      });
    })
    .catch((e) => {
      messageError($q, e);
    })
    .finally(() => {
      hideLoader();
    });
};

const fetcheducationLevel = async () => {
  showLoader();
  await http
    .get(config.API.educationLevel)
    .then((res) => {
      const data = res.data.result;
      let option: DataOption[] = [];
      data.map((r: DataOption) => {
        option.push({ id: r.id.toString(), name: r.name.toString() });
      });
      educationLevelOptions.value = option;
    })
    .catch((e) => {
      messageError($q, e);
    })
    .finally(() => {
      hideLoader();
    });
};

/**
 * กดดูข้อมูลก่อนหน้า
 */
const clickPrevious = () => {
  rowIndex.value -= 1;
  const row = rows.value[rowIndex.value];
  educationLevel.value = row.educationLevel;
  educationLevelId.value = row.educationLevelId;
  major.value = row.major;
  scores.value = row.scores;
  name.value = row.name;
  duration.value = row.duration;
  id.value = row.id;
  checkRowPage();
};

/**
 * กดดูข้อมูลต่อไป
 */
const clickNext = () => {
  rowIndex.value += 1;
  const row = rows.value[rowIndex.value];
  educationLevel.value = row.educationLevel;
  educationLevelId.value = row.educationLevelId;
  major.value = row.major;
  scores.value = row.scores;
  name.value = row.name;
  duration.value = row.duration;
  id.value = row.id;
  checkRowPage();
};

/**
 * เช็คปุ่มดูข้อมูล ย้อน กับ ต่อไป ว่าต้องแสดงไหม
 */
const checkRowPage = () => {
  editRow.value = false;
  next.value = true;
  previous.value = true;
  if (rowIndex.value + 1 >= rows.value.length) {
    next.value = false;
  }
  if (rowIndex.value - 1 < 0) {
    previous.value = false;
  }
};

/**
 * กดปุ่มแก้ไขใน dialog
 */
const clickEdit = () => {
  next.value = false;
  previous.value = false;
};

/**
 * กดปุ่มเพิ่มด้านบน table
 */
const clickAdd = () => {
  addRow();
};

const checkDelete = (row: RequestItemsObject) => {
  rawItem.value = row;
  modalDelete(
    $q,
    "ยืนยันการลบข้อมูล",
    "หากต้องการลบกดให้กดตกลง",
    clickDeleteRow
  );
};

/**
 * ลบข้อมูลใน table
 */
const clickDeleteRow = async () => {
  if (rawItem.value != null) {
    showLoader();
    await http
      .delete(config.API.candidateAdminEducation(rawItem.value.id))
      .then(() => {
        success($q, "ลบข้อมูลสำเร็จ");
      })
      .catch((e) => {
        messageError($q, e);
      })
      .finally(async () => {
        await fetchData();
      });
  } else {
    await fetchData();
  }
};

/**
 * กดบันทึกใน dialog
 */
const clickSave = async () => {
  myForm.value.validate().then(async (result: boolean) => {
    if (result) {
      if (modalEdit.value) {
        await editData();
      } else {
        await saveData();
      }
    }
  });
};

/**
 * บันทึกเพิ่มข้อมูล
 */
const saveData = async () => {
  showLoader();
  await http
    .post(config.API.candidateAdminEducation(candidateId.value), {
      educationLevelId: educationLevelId.value,
      major: major.value,
      scores: scores.value,
      name: name.value,
      durationStart: dateToISO(new Date(duration.value[0])),
      durationEnd: dateToISO(new Date(duration.value[1])),
    })
    .then(() => {
      success($q, "บันทึกข้อมูลสำเร็จ");
    })
    .catch((e) => {
      messageError($q, e);
    })
    .finally(async () => {
      modal.value = false;
      await fetchData();
    });
};

/**
 * บันทึกแก้ไขข้อมูล
 */
const editData = async () => {
  showLoader();
  await http
    .put(config.API.candidateAdminEducation(id.value), {
      educationLevelId: educationLevelId.value,
      major: major.value,
      scores: scores.value,
      name: name.value,
      durationStart: dateToISO(new Date(duration.value[0])),
      durationEnd: dateToISO(new Date(duration.value[1])),
    })
    .then(() => {
      success($q, "บันทึกข้อมูลสำเร็จ");
    })
    .catch((e) => {
      messageError($q, e);
    })
    .finally(async () => {
      modal.value = false;
      await fetchData();
    });
};

const checkClose = async () => {
  if (editRow.value == true) {
    modalConfirm(
      $q,
      "ข้อมูลมีการแก้ไข",
      "ยืนยันการดำเนินต่อใช่หรือไม่",
      clickClose
    );
  } else {
    await clickClose();
  }
  await fetchData();
};

/**
 * กดปิด dialog
 */
const clickClose = async () => {
  modal.value = false;
  editRow.value = false;
  next.value = false;
  previous.value = false;
};

/**
 * กดเลือกข้อมูลที่จะแก้ไข
 * @param props ค่า props ใน row ที่เลือก
 */
const selectData = (props: DataProps) => {
  modalEdit.value = true;
  modal.value = true;
  editRow.value = false;
  rawItem.value = props.row;
  rowIndex.value = props.rowIndex;
  educationLevel.value = props.row.educationLevel;
  educationLevelId.value = props.row.educationLevelId;
  major.value = props.row.major;
  scores.value = props.row.scores;
  name.value = props.row.name;
  duration.value = props.row.duration;
  id.value = props.row.id;
  next.value = false;
  previous.value = false;
};

/**
 * กดปุ่มเพิ่มบน table
 */
const addRow = () => {
  modalEdit.value = false;
  modal.value = true;
  educationLevel.value = "";
  educationLevelId.value = "";
  major.value = "";
  scores.value = null;
  name.value = "";
  duration.value = [new Date(), new Date()];
};
/**
 * เช็คว่ามีการแก้ไขข้อมูล
 */
const clickEditRow = () => {
  editRow.value = true;
};

/**
 * validate input ใน dialog
 */
const validateData = async () => {
  checkValidate.value = true;
  await myForm.value.validate().then((result: boolean) => {
    if (result == false) {
      checkValidate.value = false;
    }
  });
};

/**
 * class จัดรูปแบบแสดงระหว่างข้อมูลที่แก้ไขหรือแสดงเฉยๆ
 * @param val ข้อมูล input สำหรับแก้ไขหรือไม่
 */
const getClass = (val: boolean) => {
  return {
    "full-width inputgreen cursor-pointer": val,
    "full-width cursor-pointer": !val,
  };
};
</script>
<style lang="scss">
.modalfix {
  position: fixed !important;
}
</style>
